#ifndef SHARED_MEMORY_H
#define SHARED_MEMORY_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

//ID-Speicherbereich
extern int memory_id;
//Größe des Speicherbereichs hier 8MB (8000)
#define SHMMAXSIZE 8000
key_t key 1234;


//Shared-Memory-Segment erstellen oder öffnen – shmget()
void shared_memory_init(key_t key);

//Shared-Memory-Segment id weiterreichen
int get_shared_memory_id();

//Ein Shared-Memory-Segment abfragen, ändern oder löschen – shmctl()
void delet_shared_memory();

//Shared-Memory-Segment an einen Prozess anbinden (attach) – shmat()
void attach_process(void *myProcess);

//Ein Shared-Memory-Segment loslösen – shmdt()
void release_memory();

#endif //SHARED_MEMORY_H
